import { T, cond, pipe, always, not, is, contains, __ } from 'ramda'

const operations = ['add', 'replace', 'test', 'remove', 'move', 'copy']

const isOperation = cond([
  [
    pipe(is(String), not),
    always('The operation property must be a string')
  ],
  [
    pipe(contains(__, operations), not),
    always(`The operation name is not among the valid names ${operations}`)
  ],
  [T, T]
])

export default isOperation
