import { T, pipe, cond, not, always, is, test } from 'ramda'
import decodePath from './decodePath'
import pathExp from './pathExp'

const isPath = cond([
  [
    pipe(is(String), not),
    always('The path must be a string')
  ],
  [
    pipe(test(pathExp), not),
    x => `The path "${x}" did not match the encoded path regexp: ${pathExp}`
  ],
  [
    pipe(decodePath, test(pathExp), not),
    x => `The path "${x}" did not match, after decoding, the decoded path regexp: ${pathExp}`
  ],
  [T, T]
])

export default isPath
